# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2011 Agile Business Group sagl (<http://www.agilebg.com>)
#    Copyright (C) 2011 DeneroTeam. (<http://www.deneroteam.com>)
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv

class res_partner_banner(osv.osv):    
    _name = "res.partner.banner"
    _columns = { 
        'name': fields.char('Name', size=64),
        'group_ids': fields.many2many('res.partner', 'res_partner_res_parner_banner_rel','group_id','banner_id','Groups'),
    }
    _order = 'name'
res_partner_banner()

class res_partner(osv.osv):    
    _inherit = "res.partner"
    _columns = { 
        'banner_ids': fields.many2many('res.partner.banner', 'res_partner_res_parner_banner_rel','banner_id','group_id','Banners'),
    }
res_partner()

class partner_pos_address(osv.osv):    
    _inherit = "res.partner.address"
    _columns = {
        "is_pos" : fields.boolean("Is Pos?"),
        #'group': fields.many2one("res.partner", "Group" ),
        "banner_id" : fields.many2one("res.partner.banner","Banner"),
        'director_ids' : fields.one2many('res.partner.director',"address_id","Director"),
        'working_day_ids' : fields.one2many("res.partner.attendence","address_id","Working Day"),
        'type': fields.selection( [ ('default','Default'),('invoice','Invoice'), ('delivery','Delivery'), ('contact','Contact'), ('other','Other'),('pos','POS') ],'Address Type', help="Used to select automatically the right address according to the context in sales and purchases documents."),
    }
    _order = 'name desc, city desc'
    
partner_pos_address()

class res_partner(osv.osv):    
    _inherit = "res.partner"
    _columns = {
        'address': fields.one2many('res.partner.address', 'partner_id', 'Contacts',domain=[('type','!=','pos')]),
        'pos_address': fields.one2many('res.partner.address', 'partner_id', 'POS Address',domain=[('type','=','pos')]),
        }
    
res_partner()

class res_partner_department(osv.osv):    
    _name = "res.partner.department"
    _columns = {
       'name': fields.char('Name', size=64),
    }
res_partner_department()

class res_partner_director(osv.osv):    
    _name = "res.partner.director"
    _columns = {
        'name': fields.char('Name', size=64),
        'code': fields.char('Code',size=64, readonly=True),
        "department_id" : fields.many2one("res.partner.department" , "Department"),
        "phone" : fields.char("Phone" , size = 16),
        "email" : fields.char("E-mail", size = 64),
        'address_id' : fields.many2one('res.partner.address',"Address"),
    }
    _defaults = {
        
        'code': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'res.partner.director'),
     }
res_partner_director()

class res_partner_attendence(osv.osv):
    _name = "res.partner.attendence"
    _rec_name="dayofweek"
    _description = "Work Detail"
    _columns = {
        'dayofweek': fields.selection([('0','Monday'),('1','Tuesday'),('2','Wednesday'),('3','Thursday'),('4','Friday'),('5','Saturday'),('6','Sunday')], 'Day of week'),
        'hour_from' : fields.float('Work from', size=8, required=True, help="Working time will start from"),
        'hour_to' : fields.float("Work to", size=8, required=True, help="Working time will end at"),
        'address_id' : fields.many2one('res.partner.address',"Address"),
    }
    _order = 'dayofweek, hour_from'
res_partner_attendence()